import java.io.File;
import java.io.IOException;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.awt.image.ConvolveOp;
import java.awt.image.Kernel;
import java.io.File;
import javax.imageio.ImageIO;
import java.lang.* ;
import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.regex.*;


public class Omatomekun
{
	static int numberOfLines ;
	static int numberOfImg ;
	static int pixsOfEachImg[] = new int[2];
	static int offset ;
	static ImgFileNameServer fs ;
	static OmatomekunConfig config ;
	static String errorMessage ;
	
	public static int Omatomekun(OmatomekunConfig e){
		config = e ;
		fs = new ImgFileNameServer() ;
		numberOfImg = fs.ImgFileNameServer(config) ;
		numberOfLines = config.getLines() ;
		pixsOfEachImg[0] = config.getYoko() ;
		pixsOfEachImg[1] = config.getTate() ;
//		System.out.println("hoge->"+numberOfLines ) ;
		return numberOfImg ;
	}

	public static int Omatomekun(OmatomekunConfig e,  ImgFileNameServer f){
		config = e ;
		fs = f;
//		numberOfImg = fs.ImgFileNameServer(config) ;
		numberOfImg = fs.getNumberOfSelImgFiles(0);
		numberOfLines = config.getLines() ;
		pixsOfEachImg[0] = config.getYoko() ;
		pixsOfEachImg[1] = config.getTate() ;
//		System.out.println("hoge->"+numberOfLines ) ;
		return numberOfImg ;
	}


	public static void putNumberOfLines(int e){ numberOfLines = e ;}
	public static void putNumberOfImg(int e){ numberOfImg = e ;}
	public static void putPixsOfEachImg(int e[]){
		pixsOfEachImg[0] = e[0];
		pixsOfEachImg[1] = e[1];
	}
	
	
	public static BufferedImage shukusyo(BufferedImage e){
		try{
			BufferedImage dest1 = new BufferedImage( pixsOfEachImg[0] ,
																				pixsOfEachImg[1] ,
																			e.getType() );
			double i = (double)pixsOfEachImg[0]/(double)e.getWidth() ;
			double j = (double)pixsOfEachImg[1]/(double)e.getHeight() ;
			AffineTransformOp atOp = new AffineTransformOp(
									AffineTransform.getScaleInstance(i, j), null);
			atOp.filter(e, dest1);
	//http://www.atmarkit.co.jp/bbs/phpBB/viewtopic.php?mode=viewtopic&topic=20241&forum=12&start=16
			return dest1 ;
		}
		catch(Exception f){
			System.out.println("Ȃ`̃t@Co܂Bt@C`m߉B") ;
//			System.out.println("G[ڍ:"+e) ;
			System.out.println("̃t@C̃bNĂ邩AjĂ邱Ƃl܂B\ñXLbvč܂B") ;
//			errorMessage = errorMessage + "file:"+fs.getImgSelFileName(i)+
//						"͈Ȃ`̗lłB\󂠂܂B\n" ;
			errorMessage = errorMessage + "G[ڍ:"+e+"\n" ;
			return new BufferedImage(pixsOfEachImg[0], pixsOfEachImg[1], BufferedImage.TYPE_INT_BGR );}
	}

	public static BufferedImage shukusyo(BufferedImage e, String fn){
		try{
			BufferedImage dest1 = new BufferedImage( pixsOfEachImg[0] ,
																				pixsOfEachImg[1] ,
																			e.getType() );
			double i = (double)pixsOfEachImg[0]/(double)e.getWidth() ;
			double j = (double)pixsOfEachImg[1]/(double)e.getHeight() ;
			
//			double motoHiritsu  = (double)e.getWidth() / (double)e.getHeight() ;
//			double naosuHiritsu = (double)pixsOfEachImg[0] / (double)pixsOfEachImg[1] ;
			boolean tateyoko ;
//			if( (motoHiritsu-naosuHiritsu)*(motoHiritsu-naosuHiritsu) > (1.1*1.1) || (motoHiritsu-naosuHiritsu)*(motoHiritsu-naosuHiritsu) < (0.9*0.9) ){
			if( (i/j)>1.1 || (i/j)<0.9 ){
				tateyoko = true ;
			}
			else tateyoko = false ;
			
			if(config.getTateYoko()==0) tateyoko = false ;
			offset = 0;
			if(tateyoko){
//			if(true){
				Graphics2D g2 = dest1.createGraphics();
				g2.setColor(Color.gray);
				g2.fillRect(0,0,pixsOfEachImg[0],pixsOfEachImg[1]) ;
				g2.drawImage(dest1, 0, 0, null);
//				System.out.println(i+","+j);
//				if(i<1.0 || j<1.0){
				if(true){
					BufferedImage dest2 ;
					if(i>j){
//					if(true){
						int newWidth = (int) ((double)e.getWidth()*j) + 1; 
						dest2 = new BufferedImage( newWidth ,pixsOfEachImg[1] ,e.getType() );
//						dest2 = new BufferedImage( 100 ,pixsOfEachImg[1] ,BufferedImage.TYPE_INT_BGR );
						AffineTransformOp atOp = new AffineTransformOp(
										AffineTransform.getScaleInstance(j, j), AffineTransformOp.TYPE_BILINEAR);
						atOp.filter(e, dest2);
//						int offset =(int)( (pixsOfEachImg[0]-newWidth) * 0.5 ) ;
//						offset = offset + ( (pixsOfEachImg[0]-newWidth) ) ;
						offset = ( (pixsOfEachImg[0]-dest2.getWidth()) ) ;
						if(offset>pixsOfEachImg[0]) offset = pixsOfEachImg[0]-1 ;
//						offset = 0 ;
						
//						offset = ( (pixsOfEachImg[0]-100) ) ;
						
						for(int iiyoko=0 ; iiyoko<dest2.getWidth() ; iiyoko++){
							for(int iitate=0 ; iitate<dest2.getHeight()  ; iitate++){
//								dest1.setRGB(offset+iiyoko,iitate, dest2.getRGB(iiyoko,iitate) );						
								dest1.setRGB(iiyoko,iitate, dest2.getRGB(iiyoko,iitate) );						
							}
						}
						
					}
					if(j>i){
//						System.out.println(fn+"in") ;
						int newHeight = (int) ((double)e.getHeight()*i) ; 
						dest2 = new BufferedImage( pixsOfEachImg[0] ,newHeight ,e.getType() );
						AffineTransformOp atOp = new AffineTransformOp(
										AffineTransform.getScaleInstance(i, i), AffineTransformOp.TYPE_BILINEAR);
						atOp.filter(e, dest2);
						int offset =(int)( (pixsOfEachImg[1]-newHeight) * 0.5 ) ;
						for(int iiyoko=0 ; iiyoko<dest2.getWidth() ; iiyoko++){
							for(int iitate=0 ; iitate<dest2.getHeight()  ; iitate++){
								dest1.setRGB(iiyoko,offset+iitate, dest2.getRGB(iiyoko,iitate) );						
							}
												
						}
						offset = 0 ;				
					}
				}
			}
			else{
			offset = 0 ;
//			if(config.getHinshitu()==1){
				AffineTransformOp atOp = new AffineTransformOp(
										AffineTransform.getScaleInstance(i, j), AffineTransformOp.TYPE_BILINEAR);
				atOp.filter(e, dest1);
			}
//			}
//			else{
//				AffineTransformOp atOp = new AffineTransformOp(
//										AffineTransform.getScaleInstance(i, j), AffineTransformOp.TYPE_NEAREST_NEIGHBOR );
//				atOp.filter(e, dest1);
//			}
			
			if(config.getName()==1){
//			if(true){
				Pattern pattern ;
//				if(fn.charAt(0)!='/'){
				if(fn.charAt(0)=='C' && fn.charAt(1)==':'){
					pattern = Pattern.compile(fn.substring(2,3)+fn.substring(2,3));
				}
				else{
					pattern = Pattern.compile("[/]");
				}
//				Pattern pattern = Pattern.compile("[\\/_]");
				String[] str = pattern.split(fn);
				String fn2 = str[str.length-1] ;
				
//				System.out.println("178") ;
				
				Graphics2D g = dest1.createGraphics();
				int ds=1 ;
				g.setColor(Color.black);
				g.drawString(fn2, 5+ds,pixsOfEachImg[1]-5+ds);
				g.drawString(fn2, 5-ds,pixsOfEachImg[1]-5+ds);
				g.drawString(fn2, 5+ds,pixsOfEachImg[1]-5-ds);
				g.drawString(fn2, 5-ds,pixsOfEachImg[1]-5-ds);
				g.setColor(Color.white);
				g.drawString(fn2, 5,pixsOfEachImg[1]-5);
				
				g.drawImage(dest1, 0, 0, null);
			}
			
			return dest1 ;
		}
		catch(Exception f){
			System.out.println("Ȃ`̃t@Co܂Bt@C`m߉B") ;
			System.out.println("G[ڍ:"+e+"\n") ;
			System.out.println("̃t@C̃bNĂ邩AjĂ邱Ƃl܂B\ñXLbvč܂B") ;
			errorMessage = errorMessage + "file:"+fn+
						"͈Ȃ`̗lłB\󂠂܂B\n" ;
			errorMessage = errorMessage + "G[ڍ:"+e +"\n";
			offset = 0 ; 
			return new BufferedImage(pixsOfEachImg[0], pixsOfEachImg[1], BufferedImage.TYPE_INT_BGR );}
	}

	public static int omatomechu(OmatomekunGUI progress){
		BufferedImage src ;
		BufferedImage out ;
		BufferedImage omatomego ;
		int imaNoTate=0; int imaNoYoko=0;
		int MaxYoko = 0 ;
		errorMessage = "" ;
		
		if(numberOfImg<1){
			errorMessage = errorMessage + "t@C܂B\n" ;
			progress.errorDlg(errorMessage) ;
			System.out.println("t@C܂B"); return 0;}
		
//		System.out.println(numberOfLines+"\n"+numberOfImg) ;
		System.out.println("mےB") ;
		int tmp = (int)(numberOfImg/numberOfLines) ;
//		System.out.println(pixsOfEachImg[0]*numberOfLines + "," +
//																pixsOfEachImg[1]*tmp) ;
		if(((double)numberOfImg/(double)numberOfLines) > (double)tmp){
			tmp ++ ;
		}
		try{
		if(pixsOfEachImg[0]*numberOfLines > 363 && config.getLogo()==1){
			omatomego = new BufferedImage(pixsOfEachImg[0]*numberOfLines,
																pixsOfEachImg[1]*tmp + 12, 
																BufferedImage.TYPE_INT_BGR);
		}
		else{
			omatomego = new BufferedImage(pixsOfEachImg[0]*numberOfLines,
																pixsOfEachImg[1]*tmp, 
																BufferedImage.TYPE_INT_BGR);
		}}
		catch(Exception er){
			progress.errorDlg("G[B炭javaK胁słB\n邽߂ɂ̓t@C̐炷A"+
			"R}hCjart@ĈtH_܂ňړ\n"+
			"java -Xmx512m -jar Omatomekun.jarƓ͂ĂB\n"+
			"mۗʂ𑝂₷Ƃo܂BR[h-5\n"+
			"G[ڍׁF"+er);
			return -1;
		}
		
//		if(config.getTateYoko()==1){
//		if(true){
//			Graphics2D g = omatomego.createGraphics();
//			g.setColor(Color.white);
//			g.drawRect
//			
//			g.drawImage(omatomego, 0, pixsOfEachImg[1]-2, null);
//		}
		
		Graphics2D g3 = omatomego.createGraphics();
		g3.setColor(Color.gray);
		g3.fillRect(0,0,pixsOfEachImg[0]*numberOfLines, pixsOfEachImg[1]*tmp) ;
		g3.drawImage(omatomego, 0, 0, null);
		
		
		offset = 0 ;
		
		double pr = (double)( 35.0 / ((double) numberOfImg));
		for(int i=0; i<numberOfImg; i++){
			String pro = new String() ;
			pro = "[" + i +"/" +numberOfImg+"]";
			pro = pro + (int)(100.0 * (double)i/(double)numberOfImg) + "%" ;
//			pro = pro + pr ;
			for(int j=0; j<(int)(pr*(double)i) ; j++){
				pro = pro + "|";
			}
			
			pro = pro+"r" ;
			progress.setString(pro) ;

			if(config.getTateYoko()==0 && i%numberOfLines == 0 && i != 0){
				imaNoTate = imaNoTate + pixsOfEachImg[1] ;
				imaNoYoko = 0 ;}

//			if(config.getTateYoko()==1 && (omatomego.getWidth()-imaNoYoko) < (pixsOfEachImg[0]-offset)){
//				imaNoTate = imaNoTate + pixsOfEachImg[1] ;
//				imaNoYoko = 0 ;
//				offset = 0;
//				System.out.println("s");
//				}

				
			if( fs.getImgSelFileName(i).indexOf(".jpg",0) >0 || fs.getImgSelFileName(i).indexOf(".jpeg",0) >0
		 	|| fs.getImgSelFileName(i).indexOf(".JPG",0) >0 || fs.getImgSelFileName(i).indexOf(".JPEG",0) >0){
//				|| fs.getImgSelFileName(i).indexOf(".tiff",0) >0 ||fs.getImgSelFileName(i).indexOf(".tif",0) >0 || fs.getImgSelFileName(i).indexOf(".bmp",0) >0){
				try{
//					src =  ImageIO.read (new File(fs.getImgSelFileName(i) ) );}
					src =  ImageIO.read (new File(fs.getImgSelFileName(i) ) );}
				catch(Exception e){
					System.out.println("file:"+fs.getImgSelFileName(i)+"͈Ȃ`̗lłB\󂠂܂B") ;
					System.out.println("G[ڍ:"+e) ;
					src = new BufferedImage(pixsOfEachImg[0], pixsOfEachImg[1], BufferedImage.TYPE_INT_BGR );
					errorMessage = errorMessage + "file:"+fs.getImgSelFileName(i)+
								"͈Ȃ`̗lłB\󂠂܂B\n" ;
					errorMessage = errorMessage + "G[ڍ:"+e+"\n" ;
				}
			}
			else{
				if(!(fs.getImgSelFileName(i).indexOf(".bmp",0) >0 || fs.getImgSelFileName(i).indexOf(".BMP",0) >0)){
					Image img = Toolkit.getDefaultToolkit().createImage( fs.getImgSelFileName(i));
					Component com = new Panel();
					MediaTracker mt = new MediaTracker(com);
					mt.addImage(img, 0);
					try{
						mt.waitForID(0);  // ImageSɓǂݍޏ
					}
					catch(InterruptedException e){}
					
 					//   ImageBufferedImageɕϊ鏈
					try{src = new BufferedImage(img.getWidth(null),img.getHeight(null),BufferedImage.TYPE_3BYTE_BGR); } // BufferedImageIuWFNg쐬}
					catch(Exception e){
						System.out.println("file:"+fs.getImgSelFileName(i)+"͈Ȃ`̗lłB\󂠂܂B") ;
						System.out.println("G[ڍ:"+e) ;
						errorMessage = errorMessage + "file:"+fs.getImgSelFileName(i)+
									"͈Ȃ`̗lłB\󂠂܂B\n" ;
						errorMessage = errorMessage + "G[ڍ:"+e+"\n" ;
						src = new BufferedImage(pixsOfEachImg[0], pixsOfEachImg[1], BufferedImage.TYPE_INT_BGR );
					}
					Graphics g = src.createGraphics();  // Graphics̎擾
					try{g.drawImage(img,0,0,null);}  // BufferedImageɕ`悳
					catch(Exception er){
						errorMessage = errorMessage + "file:"+fs.getImgSelFileName(i)+
									"͈Ȃ`̗lłB\󂠂܂B\n" ;
						errorMessage = errorMessage + "G[ڍ:"+er+"\n" ;
					}
				}
				else{
//					bmp̏Bhttp://www.sm.rim.or.jp/~shishido/jbmp.html
					try{
						byte binary[] = new byte[(int)((new File(fs.getImgSelFileName(i))).length())];
						FileInputStream f=new FileInputStream(fs.getImgSelFileName(i)); f.read(binary); f.close();
						if (binary[0]!='B' || binary[1]!='M' || binary[28]!=24){
							System.out.println("file:"+fs.getImgSelFileName(i)+"͈Ȃ`̗lłB\󂠂܂B") ;
							System.out.println("G[ڍ:"+"24BitBMPł͂Ȃ悤łB") ;
							errorMessage = errorMessage + "file:"+fs.getImgSelFileName(i)+
										"͈Ȃ`̗lłB\󂠂܂B\n" ;
							errorMessage = errorMessage + "G[ڍ:"+"24BitBMPł͂Ȃ悤łB"+"\n" ;
							src = new BufferedImage(pixsOfEachImg[0], pixsOfEachImg[1], BufferedImage.TYPE_INT_BGR );
						}
						else{
							int w, h, l ;
							if(binary[18]<0){ w= (256+binary[18])+(int)binary[19]*256;}
							else                   { w= (      +binary[18])+(int)binary[19]*256;}
							if(binary[22]<0) { h=(256+binary[22])+(int)binary[23]*256;}
							else                   { h=binary[22]+(int)binary[23]*256;}
							if ((w*3) % 4==0) { l=w*3;}
							else                           { l=w*3+(4-(w*3) % 4);}
							byte [] pixel = new byte[w*3*h];
							 for (int ii=0;ii<h;ii++){
								for (int jj=0;jj<w;jj++) {
									int adr=jj*3+(h-ii-1)*w*3;
									int adr2=binary[10]+jj*3+ii*l;
									pixel[adr]=binary[adr2+2];
									pixel[adr+1]=binary[adr2+1];
									pixel[adr+2]=binary[adr2];
								}
							}
							
							src =new BufferedImage(w,h,BufferedImage.TYPE_3BYTE_BGR);
							src.getRaster().setDataElements(0,0,w,h,pixel);
						}
					}
					catch (Exception e) {
						System.out.println("file:"+fs.getImgSelFileName(i)+"͈Ȃ`̗lłB\󂠂܂B") ;
						System.out.println("G[ڍ:"+e) ;
						errorMessage = errorMessage + "file:"+fs.getImgSelFileName(i)+
									"͈Ȃ`̗lłB\󂠂܂B\n" ;
						errorMessage = errorMessage + "G[ڍ:"+e+"\n" ;
						src = new BufferedImage(pixsOfEachImg[0], pixsOfEachImg[1], BufferedImage.TYPE_INT_BGR );
					}
				}
			}
			System.out.println("file["+(i+1)+"/"+numberOfImg+"]:"+fs.getImgSelFileName(i)+"B") ;
			out = shukusyo(src, fs.getImgSelFileName(i)) ;
			
			if(config.getTateYoko()==1 && (omatomego.getWidth()-imaNoYoko) < (pixsOfEachImg[0]-offset)){
				imaNoTate = imaNoTate + pixsOfEachImg[1] ;
				imaNoYoko = 0 ;
//				offset = 0;
				System.out.println("s");
			}
							
//			System.out.println(offset);
			if(offset<0){
				System.out.println("offset="+offset+";");
				break ;
			}
			if(imaNoYoko<0){
				System.out.println("imaNoYoko="+imaNoYoko+";");
				break ;
			}			
			
			for(int tate=0; tate<pixsOfEachImg[1]; tate++){
//				for(int yoko=0; yoko<pixsOfEachImg[0]; yoko++){
				for(int yoko=0; yoko<(pixsOfEachImg[0]-offset); yoko++){
					try{
						omatomego.setRGB(imaNoYoko,imaNoTate, out.getRGB(yoko,tate)) ;
					}
					catch(Exception err){
//					System.out.println(offset+"***"+imaNoYoko+","+imaNoTate+","+","+yoko+","+tate) ;
					}
					imaNoYoko++;
//					System.out.println("i="+i+"--byte="+tate*yoko) ;
				}
//				imaNoYoko = imaNoYoko - pixsOfEachImg[0] ;
				imaNoYoko = imaNoYoko - pixsOfEachImg[0] + offset ;
				imaNoTate++;
				
				if(tate%4 == 0) pro = pro.substring(0,pro.length()-1) + "-";
				else if(tate%4 == 1) pro = pro.substring(0,pro.length()-1) + "\\";
				else if(tate%4 == 2) pro = pro.substring(0,pro.length()-1) + "|";
				else if(tate%4 == 3) pro = pro.substring(0,pro.length()-1) + "/";
				
				progress.setString(pro) ;				
			}
			imaNoTate = imaNoTate - pixsOfEachImg[1] ;
//			imaNoYoko = imaNoYoko + pixsOfEachImg[0] ;
			imaNoYoko = imaNoYoko + pixsOfEachImg[0] - offset ;

			if(imaNoYoko>MaxYoko) MaxYoko = imaNoYoko ;
		}
		imaNoTate = imaNoTate + pixsOfEachImg[1] ;
		
		if(config.getTateYoko()==1){
//		if(true){
			BufferedImage tmptmp ;
			if(pixsOfEachImg[0]*numberOfLines > 363 && config.getLogo()==1){
				tmptmp = new BufferedImage(MaxYoko, imaNoTate + 12, BufferedImage.TYPE_INT_BGR);
				for(int iii=0; iii<tmptmp.getWidth(); iii++){
					for(int jjj=0; jjj<tmptmp.getHeight(); jjj++){
						tmptmp.setRGB(iii,jjj, omatomego.getRGB(iii,jjj)) ;
					}
				}
			}
			else{
				tmptmp = new BufferedImage(MaxYoko, imaNoTate, BufferedImage.TYPE_INT_BGR);
				for(int iii=0; iii<tmptmp.getWidth(); iii++){
					for(int jjj=0; jjj<tmptmp.getHeight(); jjj++){
						tmptmp.setRGB(iii,jjj, omatomego.getRGB(iii,jjj)) ;
					}
				}
			}
			omatomego = tmptmp ;
		}
		
				
		if(pixsOfEachImg[0]*numberOfLines > 363 &&config.getLogo()==1){
			Logo e = new Logo();
//			BufferedImage logo = e.logo(pixsOfEachImg[0]*numberOfLines) ;
			BufferedImage logo = e.logo(omatomego.getWidth()) ;
			for(int tate=0; tate<12; tate++){
				imaNoYoko=0;
//				for(int yoko=0; yoko<(pixsOfEachImg[0]*numberOfLines); yoko++){
				for(int yoko=0; yoko<omatomego.getWidth(); yoko++){
//					System.out.println(yoko+","+imaNoYoko+","+imaNoTate+","+logo.getWidth()+","+logo.getHeight()) ;
					omatomego.setRGB(imaNoYoko,imaNoTate, logo.getRGB(yoko,tate) );
					imaNoYoko++;
				}
				imaNoTate++;
			}
		}
		
		try{ImageIO.write(omatomego, config.getOutFormat(), new File(config.getOutFile()));
			System.out.println("摜B>> "+config.getOutFile()) ;
			progress.setString("摜B>> "+numberOfImg+"̉摜B") ;
		}
		catch(Exception t){
			System.out.println("摜ݎsB" + t) ;
		}
		if(errorMessage != "") progress.errorDlg(errorMessage) ;
		return 0;
	}
	
	public static int omatomechu(){
		BufferedImage src ;
		BufferedImage out ;
		BufferedImage omatomego ;
		int imaNoTate=0; int imaNoYoko=0;
		
		if(numberOfImg<1){
			System.out.println("t@C܂B"); return 0;}
		
//		System.out.println(numberOfLines+"\n"+numberOfImg) ;
		System.out.println("mےB") ;
		int tmp = (int)(numberOfImg/numberOfLines) ;
//		System.out.println(pixsOfEachImg[0]*numberOfLines + "," +
//																pixsOfEachImg[1]*tmp) ;
		if(((double)numberOfImg/(double)numberOfLines) > (double)tmp){
			tmp ++ ;
		}
		if(pixsOfEachImg[0]*numberOfLines > 363){
			omatomego = new BufferedImage(pixsOfEachImg[0]*numberOfLines,
																pixsOfEachImg[1]*tmp + 12, 
																BufferedImage.TYPE_INT_BGR);
		}
		else{
			omatomego = new BufferedImage(pixsOfEachImg[0]*numberOfLines,
																pixsOfEachImg[1]*tmp, 
																BufferedImage.TYPE_INT_BGR);
		}
		double pr = (double)( 20.0 / ((double) numberOfImg));
		for(int i=0; i<numberOfImg; i++){
			String pro = new String() ;
			pro = "prog.: [" + i +"." +numberOfImg+"]";
//			pro = pro + pr ;
			for(int j=0; j<(int)(pr*(double)i) ; j++){
				pro = pro + ">";
			}
//			progress.setString(pro) ;
			if(i%numberOfLines == 0 && i != 0){
				imaNoTate = imaNoTate + pixsOfEachImg[1] ;
				imaNoYoko = 0 ;}
			if( fs.getImgSelFileName(i).indexOf(".jpg",0) >0 || fs.getImgSelFileName(i).indexOf(".jpeg",0) >0
			 	|| fs.getImgSelFileName(i).indexOf(".JPG",0) >0 || fs.getImgSelFileName(i).indexOf(".JPEG",0) >0
			){
//				|| fs.getImgSelFileName(i).indexOf(".tiff",0) >0 ||fs.getImgSelFileName(i).indexOf(".tif",0) >0 || fs.getImgSelFileName(i).indexOf(".bmp",0) >0){
				try{
					src =  ImageIO.read (new File(fs.getImgSelFileName(i) ) );}
				catch(Exception e){
					System.out.println("file:"+fs.getImgSelFileName(i)+"͈Ȃ`̗lłB\󂠂܂B") ;
					System.out.println("G[ڍ:"+e) ;
					src = new BufferedImage(pixsOfEachImg[0], pixsOfEachImg[1], BufferedImage.TYPE_INT_BGR );
				}
			}
			else{
				Image img = Toolkit.getDefaultToolkit().createImage( fs.getImgSelFileName(i));
				Component com = new Panel();
				MediaTracker mt = new MediaTracker(com);
				mt.addImage(img, 0);
				try{
					mt.waitForID(0);  // ImageSɓǂݍޏ
				}
				catch(InterruptedException e){}
				
 				//   ImageBufferedImageɕϊ鏈
				try{src = new BufferedImage(img.getWidth(null),img.getHeight(null),BufferedImage.TYPE_3BYTE_BGR); } // BufferedImageIuWFNg쐬}
				catch(Exception e){
					System.out.println("file:"+fs.getImgSelFileName(i)+"͈Ȃ`̗lłB\󂠂܂B") ;
					System.out.println("G[ڍ:"+e) ;
					src = new BufferedImage(pixsOfEachImg[0], pixsOfEachImg[1], BufferedImage.TYPE_INT_BGR );
				}
				Graphics g = src.createGraphics();  // Graphics̎擾
				g.drawImage(img,0,0,null);  // BufferedImageɕ`悳
			}
			System.out.println("file["+(i+1)+"/"+numberOfImg+"]:"+fs.getImgSelFileName(i)+"B") ;
			out = shukusyo(src) ;
			for(int tate=0; tate<pixsOfEachImg[1]; tate++){
				for(int yoko=0; yoko<pixsOfEachImg[0]; yoko++){
					omatomego.setRGB(imaNoYoko,imaNoTate, out.getRGB(yoko,tate)) ;
					imaNoYoko++;
//					System.out.println("i="+i+"--byte="+tate*yoko) ;
				}
				imaNoYoko = imaNoYoko - pixsOfEachImg[0] ;
				imaNoTate++;
			}
			imaNoTate = imaNoTate - pixsOfEachImg[1] ;
			imaNoYoko = imaNoYoko + pixsOfEachImg[0] ;
		}
		imaNoTate = imaNoTate + pixsOfEachImg[1] ;
		if(pixsOfEachImg[0]*numberOfLines > 363){
			Logo e = new Logo();
			BufferedImage logo = e.logo(pixsOfEachImg[0]*numberOfLines) ;
			for(int tate=0; tate<12; tate++){
				imaNoYoko=0;
				for(int yoko=0; yoko<(pixsOfEachImg[0]*numberOfLines); yoko++){
//					System.out.println(yoko+","+imaNoYoko+","+imaNoTate+","+logo.getWidth()+","+logo.getHeight()) ;
					omatomego.setRGB(imaNoYoko,imaNoTate, logo.getRGB(yoko,tate) );
					imaNoYoko++;
				}
				imaNoTate++;
			}
		}
		
		try{
			ImageIO.write(omatomego, config.getOutFormat(), new File(config.getOutFile()));
//			ImageIO.write(omatomego, config.getOutFormat(), new File("test.jpg"));
			System.out.println("摜B>> "+config.getOutFile()) ;
//			progress.setString("摜B>> "+config.getOutFile()) ;
		}
		catch(Exception t){
			System.out.println("摜ݎsB" + t) ;
		}
		return 0;
	}	
	public static void main( String[] args )
    { // tate yoko lines
		Omatomekun e ;
		OmatomekunConfig f ;
		f= new OmatomekunConfig();
		f.init() ;
		f.setYoko(Integer.valueOf(args[0]).intValue()) ;
		f.setTate(Integer.valueOf(args[1]).intValue()) ;
		f.setLines(Integer.valueOf(args[2]).intValue());
		e = new Omatomekun() ;
		e.Omatomekun(f) ;
//		e.putPixsOfEachImg(f) ;
//		e.setConfig(f) ;
		
		e.omatomechu();
		System.out.println("\nOmatome-Kun͂gp肪Ƃ܂Bsupport : lonmei@gmail.com") ;
		System.out.println("Omatome-KunGPL\tgEFAłBςꍇ̓\[XR[h𓯕ĂB") ;
		System.out.println("copyright lonmei 2004 http://aurorae.s14.xrea.com") ;
	}
}